## sunpinyin 2.0.2

=== SConstruct ===
import platform
import os
import sys

cflags='-O2 -pipe -DHAVE_CONFIG_H '
prefix='/usr/local'
rpath=''

slmsource=['src/slm/ids2ngram/ids2ngram.cpp',
           'src/slm/ids2ngram/idngram_merge.cpp',
           'src/slm/mmseg/mmseg.cpp',
           'src/slm/tslminfo/tslminfo.cpp',
           'src/slm/tslmpack/arpa_slm.cpp',
           'src/slm/tslmpack/arpa_conv.cpp',
           'src/slm/tslmpack/slmpack.cpp',
           'src/slm/slm.cpp',
           'src/slm/slminfo/slminfo.cpp',
           'src/slm/sim_sen.cpp',
           'src/slm/sim_slm.cpp',
           'src/slm/getWordFreq/getWordFreq.cpp',
           'src/slm/slmseg/slmseg.cpp',
           'src/slm/thread/slmthread.cpp',
           'src/slm/thread/test_vc.cpp',
           'src/slm/thread/ValueCompress.cpp',
           'src/slm/slmbuild/slmbuild.cpp',
           'src/slm/slmprune/slmprune.cpp',
           'src/slm/sim_slmbuilder.cpp',
           'src/slm/tslmendian/slm_endian.cpp',
           'src/slm/tslmendian/writer.cpp',
           'src/slm/tslmendian/slm_file.cpp',
           'src/slm/sim_dict.cpp',
           'src/portability.cpp',
           'src/lexicon/trie_writer.cpp',
           'src/lexicon/genPYT.cpp',
           'src/lexicon/pytrie_gen.cpp',
           'src/lexicon/pytrie.cpp',
           'src/pinyin/pinyin_data.cpp']

imesource=['src/portability.cpp',
           'src/slm/slm.cpp',
           'src/lexicon/pytrie.cpp',
           'src/pinyin/pinyin_data.cpp',
           'src/pinyin/pinyin_seg.cpp',
           'src/pinyin/shuangpin_data.cpp',
           'src/pinyin/shuangpin_seg.cpp',
           'src/ime-core/imi_context.cpp',
           'src/ime-core/imi_data.cpp',
           'src/ime-core/lattice_states.cpp',
           'src/ime-core/imi_view.cpp',
           'src/ime-core/imi_uiobjects.cpp',
           'src/ime-core/imi_view_classic.cpp',
           'src/ime-core/imi_winHandler.cpp',
           'src/ime-core/ic_history.cpp',
           'src/ime-core/imi_funcobjs.cpp',
           'src/ime-core/imi_options.cpp',
           'src/ime-core/imi_option_event.cpp',
           'src/ime-core/userdict.cpp']

headers=['src/slm/ids2ngram/idngram.h',
         'src/slm/ids2ngram/idngram_merge.h',
         'src/slm/slm.h',
         'src/slm/tslmpack/arpa_slm.h',
         'src/slm/tslmpack/common.h',
         'src/slm/tslmpack/arpa_conv.h',
         'src/slm/sim_dict.h',
         'src/slm/sim_sen.h',
         'src/slm/sim_slm.h',
         'src/slm/thread/ValueCompress.h',
         'src/slm/sim_fmerge.h',
         'src/slm/sim_slmbuilder.h',
         'src/slm/tslmendian/slm_file.h',
         'src/slm/tslmendian/writer.h',
         'src/lexicon/pytrie_gen.h',
         'src/lexicon/trie_writer.h',
         'src/lexicon/pytrie.h',
         'src/ime-core/imi_view_classic.h',
         'src/ime-core/imi_uiobjects.h',
         'src/ime-core/lattice_states.h',
         'src/ime-core/ic_history.h',
         'src/ime-core/imi_funcobjs.h',
         'src/ime-core/imi_context.h',
         'src/ime-core/imi_winHandler.h',
         'src/ime-core/userdict.h',
         'src/ime-core/imi_option_event.h',
         'src/ime-core/imi_data.h',
         'src/ime-core/utils.h',
         'src/ime-core/imi_keys.h',
         'src/ime-core/imi_option_keys.h',
         'src/ime-core/imi_options.h',
         'src/ime-core/imi_defines.h',
         'src/ime-core/imi_view.h',
         'src/portability.h',
         'src/pinyin/segmentor.h',
         'src/pinyin/shuangpin_seg.h',
         'src/pinyin/datrie.h',
         'src/pinyin/quanpin_trie.h',
         'src/pinyin/pinyin_seg.h',
         'src/pinyin/pinyin_data.h',
         'src/pinyin/syllable.h',
         'src/pinyin/shuangpin_data.h',
         'src/pinyin/datrie_impl.h',
         'src/host_os.h',
         'src/sunpinyin.h']

AddOption('--prefix', dest='prefix', type='string', nargs=1,
          action='store', metavar='DIR', help='installation prefix')
AddOption('--rpath', dest='rpath', type='string', nargs=1,
          action='store', metavar='DIR', help='encode rpath in the executables')

if GetOption('prefix') is not None:
    prefix = GetOption('prefix')
if GetOption('rpath') is not None:
    rpath = GetOption('rpath')

cflags += ('-DSUNPINYIN_DATA_DIR=\'"%s/lib/sunpinyin/data"\'' % (prefix,))
libdir = prefix+'/lib'
libdatadir = libdir+'/sunpinyin/data'
headersdir = prefix+'/include/sunpinyin-2.0'

abi_major = 3
abi_minor = 0

#
#==============================environment==============================
#
#
def allinc():
    inc=[]
    for root, dirs, files in os.walk('src'):
        inc.append(root)
    return inc

def GetOS():
    return platform.uname()[0]

def CreateEnvironment():
    tar = 'tar'
    make = 'make'
    wget = 'wget'
    if GetOS() == 'Darwin':
        wget = 'curl -O'
    elif GetOS() == 'SunOS':
        tar = 'gtar'
        make = 'gmake'

    return Environment(ENV=os.environ, CFLAGS=cflags, CXXFLAGS=cflags,
                       TAR=tar, MAKE=make, WGET=wget,
                       CPPPATH=['.'] + allinc(), PREFIX=prefix)

env = CreateEnvironment()

if GetOS() != 'Darwin':
    env.Append(LINKFLAGS=['-Wl,-soname=libsunpinyin.so.%d' % abi_major])

if rpath != '' and GetOS() != 'Darwin':
    env.Append(LINKFLAGS='-Wl,-R -Wl,%s' % rpath)

if 'CC' in os.environ:
    print 'Warning: you\'ve set %s as C compiler' % os.environ['CC']
    env['CC']=os.environ['CC']
    
if 'CXX' in os.environ:
    print 'Warning: you\'ve set %s as C++ compiler' % os.environ['CXX']
    env['CXX']=os.environ['CXX']

if 'CFLAGS' in os.environ:
    print 'Warning: you\'ve set an external compiler flags for C.'
    env['CFLAGS'] = os.environ['CFLAGS']

if 'CXXFLAGS' in os.environ:
    print 'Warning: you\'ve set an external compiler flags for C++.'
    env['CXXFLAGS'] = os.environ['CXXFLAGS']

if 'TAR' in os.environ:
    print 'Warning: you\'ve set %s as tar' % os.environ['TAR']
    env['TAR'] = os.environ['TAR']

if 'MAKE' in os.environ:
    print 'Warning: you\'ve set %s as make' % os.environ['MAKE']
    env['MAKE'] = os.environ['MAKE']

if 'WGET' in os.environ:
    print 'Warning: you\'ve set %s as wget' % os.environ['WGET']
    env['WGET'] = os.environ['WGET']
    
#
#==============================configure================================
#
def CheckPKGConfig(context, version='0.12.0'):
    context.Message( 'Checking for pkg-config... ' )
    ret = context.TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0]
    context.Result(ret)
    return ret

def CheckPKG(context, name):
    context.Message( 'Checking for %s... ' % name )
    ret = context.TryAction('pkg-config --exists \'%s\'' % name)[0]
    context.Result(ret)
    return ret

conf = Configure(env, custom_tests={'CheckPKGConfig' : CheckPKGConfig,
                                    'CheckPKG' : CheckPKG})

config_h_content = ''

def AddConfigItem(macro_name, res):
    global config_h_content
    config_h_content += ('#define %s %s\n\n' % (macro_name, res))

def AddTestHeader(header):
    macro_name = header.replace('.', '_').replace('-', '_').replace('/', '_').upper()
    macro_name = 'HAVE_' + macro_name
    if conf.CheckCHeader(header):
        AddConfigItem(macro_name, 1)

def AddTestFunction(funcname):
    macro_name = funcname.upper()
    macro_name = 'HAVE_' + macro_name
    if conf.CheckFunc(funcname):
        AddConfigItem(macro_name, 1)

def LinkOSHeader():
    osstring = GetOS()
    header = ''
    if osstring == 'Linux':
        header = 'linux.h'
    elif osstring == 'SunOS':
        header = 'solaris.h'
    elif osstring == 'Darwin':
        header = 'mac.h'

    os.system('ln -sf ./config/%s ./src/host_os.h' % (header,));

def AppendEndianCheck():
    global config_h_content
    config_h_content += r'''
#if defined(_BIG_ENDIAN) && !defined(_LITTLE_ENDIAN)
# define WORDS_BIGENDIAN 1

#elif defined(_LITTLE_ENDIAN) && !defined(_BIG_ENDIAN)
# undef WORDS_BIGENDIAN

#elif defined(__sparc) || defined(__sparc__) \
  || defined(_POWER) || defined(__powerpc__) \
  || defined(__ppc__) || defined(__hpux) || defined(__hppa) \
  || defined(_MIPSEB) || defined(_POWER) \
  || defined(__s390__)
# define WORDS_BIGENDIAN 1

#elif defined(__i386__) || defined(__alpha__) || defined(__i386) \
  || defined(__ia64) || defined(__ia64__) \
  || defined(_M_IX86) || defined(_M_IA64) \
  || defined(_M_ALPHA) || defined(__amd64) \
  || defined(__amd64__) || defined(_M_AMD64) \
  || defined(__x86_64) || defined(__x86_64__) \
  || defined(_M_X64) || defined(__bfin__)
# undef WORDS_BIGENDIAN

#else
# error can not detect the endianness!
#endif
'''

def DoConfigure():
    if GetOption('clean'):
        return

    if GetOS() == 'Darwin':
        if not conf.CheckLibWithHeader('sqlite3', 'sqlite3.h', 'C'):
            Exit(1)
        if not conf.CheckLibWithHeader('iconv', 'iconv.h', 'C'):
            Exit(1)
    else:
        if not conf.CheckPKGConfig():
            Exit(1)
        if not conf.CheckPKG('sqlite3'):
            Exit(1)

    AddConfigItem('ENABLE_NLS', 1)
    AddConfigItem('GETTEXT_PACKAGE', '"sunpinyin2"')
    AddTestHeader('assert.h')
    AddTestFunction('bind_textdomain_codeset')
    AddTestFunction('dcgettext')
    AddTestHeader('dlfcn.h')
    AddTestFunction('exp2')
    AddTestHeader('fcntl.h')
    AddTestHeader('getopt.h')
    AddTestFunction('getopt_long')
    AddTestFunction('getpagesize')
    AddTestFunction('get_opt')
    AddTestHeader('iconv.h')
    AddTestHeader('inttypes.h')
    AddTestHeader('locale.h')
    AddTestHeader('libintl.h')
    AddTestHeader('limits.h')
    AddTestHeader('locale.h')
    AddTestFunction('log2')
    AddTestHeader('memory.h')
    AddTestFunction('memset')
    AddTestFunction('mmap')
    AddTestFunction('munmap')
    AddTestFunction('setlocale')
    AddTestFunction('strndup')
    AddTestHeader('sys/mman.h')
    AddTestHeader('sys/param.h')
    AddTestHeader('sys/stat.h')
    AddTestHeader('sys/types.h')
    AddTestHeader('unistd.h')
    AddTestHeader('wchar.h')

    # add essential package requirements
    AddConfigItem('PACKAGE', '"sunpinyin"')
    AddConfigItem('PACKAGE_NAME', '"sunpinyin"')
    AddConfigItem('PACKAGE_STRING', '"sunpinyin 2.0"')
    AddConfigItem('PACKAGE_TARNAME', '"sunpinyin"')
    AddConfigItem('PACKAGE_VERSION', '"2.0"')
    AddConfigItem('VRESION', '"2.0"')

    # append endianness checking defines
    AppendEndianCheck()
    
    # generate config.h
    f = file('config.h', 'w')
    f.write(config_h_content)
    f.close()

    # generate sunpinyin.pc
    f = file('sunpinyin-2.0.pc', 'w')
    content = (
        'prefix='+prefix,
        'exec_prefix=${prefix}',
        'libdir=${exec_prefix}/lib',
        'includedir=${exec_prefix}/include/sunpinyin-2.0',
        '',
        'Name: libsunpinyin',
        'Description: IME library based on Statistical Language Model',
        'Version: 2.0.1',
        'Requires: sqlite3',
        'Libs: -L${libdir} -lsunpinyin',
        'Cflags: ' + reduce(lambda a, b: a + ' ' + b,
                            map(lambda x: '-I${includedir}' + x[3:],
                                allinc()))
        )
    f.write(reduce(lambda a, b: a + '\n' + b, content))
    f.close()
    env = conf.Finish()

    if GetOS() != 'Darwin':
        env.ParseConfig('pkg-config sqlite3 --libs --cflags')

    LinkOSHeader()

DoConfigure()

#
#==============================compile==============================
#
env.Object(slmsource)

SConscript(['build/SConscript'], exports='env')

libname = 'libsunpinyin.so.%d.%d' % (abi_major, abi_minor)
libname_soname = 'libsunpinyin.so.%d' % abi_major
libname_link = 'libsunpinyin.so'

lib = env.SharedLibrary('sunpinyin-%d.%d' % (abi_major, abi_minor),
                        source=imesource)

env.Command('rawlm', 'build/tslmpack',
            '$MAKE -C raw WGET="$WGET" TAR="$TAR"')

env.Command('lm', 'rawlm',
            '$MAKE -C data WGET="$WGET" TAR="$TAR"')

if GetOption('clean'):
    os.environ['TAR'] = env['TAR']
    os.environ['MAKE'] = env['MAKE']
    os.system('$MAKE -C raw clean WGET="$WGET" TAR="$TAR"')

=== debian/changelog ===
sunpinyin (2.0.2-0ubuntu2) maverick; urgency=low

  * Fix endianness check on armel. LP: #642113.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 18 Sep 2010 18:45:53 +0200

sunpinyin (2.0.2-0ubuntu1) maverick; urgency=low

  * Initial Ubuntu upload, LP: #631472, LP: #631459

 -- Zhengpeng Hou <zhengpeng-hou@ubuntu.com>  Mon, 06 Sep 2010 12:23:46 +0100

sunpinyin (2.0.2-1) experimental; urgency=low

  * Initial release (Closes: #478811)

 -- Liang Guo <bluestonechina@gmail.com>  Wed, 18 Aug 2010 16:47:54 +0800

=== debian/control ===
Source: sunpinyin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Liang Guo <bluestonechina@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), scons, libsqlite3-dev, pkg-config, quilt (>= 0.46-8~)
Standards-Version: 3.9.1
Section: libs
Homepage: http://code.google.com/p/sunpinyin

Package: libsunpinyin-dev
Section: libdevel
Architecture: any
Depends: libsunpinyin3 (= ${binary:Version}), ${misc:Depends}, libsqlite3-dev
Description: Simplified Chinese Input Method from SUN (development)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the development header files that allows others 
 to write their own front-end for sunpinyin.

Package: libsunpinyin3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: sunpinyin-data
Description: Simplified Chinese Input Method from SUN (runtime)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the runtime library.

Package: sunpinyin-utils
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python
Description: Simplified Chinese Input Method from SUN (utilities)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains some utilities used by open-gram project, 
 including:
 .
 genpyt - generate the pinyin lexicon
 tslmpack - convert the ARPA format of SunPinyin back-off language 
 model to its binary representation
 tslmendian - change the byte-order of sunpinyin's threaded back-off 
 language model
 .
 and some Python programs which maybe used to import user dictionary 
 from other input method such as sougou, google, fcitx etc.

## sunpinyin 2.0.3~rc1

=== SConstruct ===
--- 
+++ 
@@ -2,9 +2,11 @@
 import os
 import sys
 
-cflags='-O2 -pipe -DHAVE_CONFIG_H '
-prefix='/usr/local'
-rpath=''
+version="2.0.3"
+abi_major = 3
+abi_minor = 0
+
+cflags='-O2 -g -pipe '
 
 slmsource=['src/slm/ids2ngram/ids2ngram.cpp',
            'src/slm/ids2ngram/idngram_merge.cpp',
@@ -99,26 +101,26 @@
          'src/pinyin/syllable.h',
          'src/pinyin/shuangpin_data.h',
          'src/pinyin/datrie_impl.h',
-         'src/host_os.h',
          'src/sunpinyin.h']
 
-AddOption('--prefix', dest='prefix', type='string', nargs=1,
-          action='store', metavar='DIR', help='installation prefix')
-AddOption('--rpath', dest='rpath', type='string', nargs=1,
-          action='store', metavar='DIR', help='encode rpath in the executables')
-
-if GetOption('prefix') is not None:
-    prefix = GetOption('prefix')
-if GetOption('rpath') is not None:
-    rpath = GetOption('rpath')
-
-cflags += ('-DSUNPINYIN_DATA_DIR=\'"%s/lib/sunpinyin/data"\'' % (prefix,))
-libdir = prefix+'/lib'
-libdatadir = libdir+'/sunpinyin/data'
-headersdir = prefix+'/include/sunpinyin-2.0'
-
-abi_major = 3
-abi_minor = 0
+# options
+AddOption('--prefix', dest='prefix', metavar='DIR',
+          help='installation prefix')
+
+AddOption('--libdir', dest='libdir', metavar='DIR',
+          help='installation libdir')
+
+AddOption('--libdatadir', dest='libdatadir', metavar='DIR',
+          help='installation libdata dir')
+
+AddOption('--rpath', dest='rpath', metavar='DIR',
+          help='encode rpath in the executables')
+
+# save the options
+opts = Variables('configure.conf')
+opts.Add('PREFIX', default='/usr/local')
+opts.Add('LIBDIR', default='/usr/local/lib')
+opts.Add('LIBDATADIR', default='/usr/local/lib')
 
 #
 #==============================environment==============================
@@ -139,21 +141,42 @@
     wget = 'wget'
     if GetOS() == 'Darwin':
         wget = 'curl -O'
+    elif GetOS() == 'FreeBSD':
+        wget = 'fetch'
+        make = 'gmake'
     elif GetOS() == 'SunOS':
         tar = 'gtar'
         make = 'gmake'
 
     return Environment(ENV=os.environ, CFLAGS=cflags, CXXFLAGS=cflags,
                        TAR=tar, MAKE=make, WGET=wget,
-                       CPPPATH=['.'] + allinc(), PREFIX=prefix)
+                       CPPPATH=['.'] + allinc())
 
 env = CreateEnvironment()
+opts.Update(env)
+
+if GetOption('prefix') is not None:
+    env['PREFIX'] = GetOption('prefix')
+    env['LIBDATADIR'] = env['PREFIX'] + '/lib'
+    env['LIBDIR'] = env['PREFIX'] + '/lib'
+
+if GetOption('libdir') is not None:
+    env['LIBDIR'] = GetOption('libdir')
+
+if GetOption('libdatadir') is not None:
+    env['LIBDATADIR'] = GetOption('libdatadir')
+
+opts.Save('configure.conf', env)
+
+libdir = env['LIBDIR']
+libdatadir = env['LIBDATADIR'] + '/sunpinyin/data'
+headersdir = env['PREFIX'] + '/include/sunpinyin-2.0'
 
 if GetOS() != 'Darwin':
     env.Append(LINKFLAGS=['-Wl,-soname=libsunpinyin.so.%d' % abi_major])
 
-if rpath != '' and GetOS() != 'Darwin':
-    env.Append(LINKFLAGS='-Wl,-R -Wl,%s' % rpath)
+if GetOption('rpath') is not None and GetOS() != 'Darwin':
+    env.Append(LINKFLAGS='-Wl,-R -Wl,%s' % GetOption('rpath'))
 
 if 'CC' in os.environ:
     print 'Warning: you\'ve set %s as C compiler' % os.environ['CC']
@@ -182,7 +205,13 @@
 if 'WGET' in os.environ:
     print 'Warning: you\'ve set %s as wget' % os.environ['WGET']
     env['WGET'] = os.environ['WGET']
-    
+
+
+# append critical cflags
+extra_cflags=' -DHAVE_CONFIG_H -DSUNPINYIN_DATA_DIR=\'"%s"\'' % libdatadir
+env.Append(CFLAGS=extra_cflags)
+env.Append(CXXFLAGS=extra_cflags)
+
 #
 #==============================configure================================
 #
@@ -198,42 +227,9 @@
     context.Result(ret)
     return ret
 
-conf = Configure(env, custom_tests={'CheckPKGConfig' : CheckPKGConfig,
-                                    'CheckPKG' : CheckPKG})
-
-config_h_content = ''
-
-def AddConfigItem(macro_name, res):
-    global config_h_content
-    config_h_content += ('#define %s %s\n\n' % (macro_name, res))
-
-def AddTestHeader(header):
-    macro_name = header.replace('.', '_').replace('-', '_').replace('/', '_').upper()
-    macro_name = 'HAVE_' + macro_name
-    if conf.CheckCHeader(header):
-        AddConfigItem(macro_name, 1)
-
-def AddTestFunction(funcname):
-    macro_name = funcname.upper()
-    macro_name = 'HAVE_' + macro_name
-    if conf.CheckFunc(funcname):
-        AddConfigItem(macro_name, 1)
-
-def LinkOSHeader():
-    osstring = GetOS()
-    header = ''
-    if osstring == 'Linux':
-        header = 'linux.h'
-    elif osstring == 'SunOS':
-        header = 'solaris.h'
-    elif osstring == 'Darwin':
-        header = 'mac.h'
-
-    os.system('ln -sf ./config/%s ./src/host_os.h' % (header,));
-
-def AppendEndianCheck():
-    global config_h_content
-    config_h_content += r'''
+def AppendEndianCheck(conf):
+    conf.config_h_text += r'''
+
 #if defined(_BIG_ENDIAN) && !defined(_LITTLE_ENDIAN)
 # define WORDS_BIGENDIAN 1
 
@@ -241,25 +237,30 @@
 # undef WORDS_BIGENDIAN
 
 #elif defined(__sparc) || defined(__sparc__) \
-  || defined(_POWER) || defined(__powerpc__) \
-  || defined(__ppc__) || defined(__hpux) || defined(__hppa) \
-  || defined(_MIPSEB) || defined(_POWER) \
+  || defined(_POWER)   || defined(__powerpc__) \
+  || defined(__ppc__)  || defined(__hpux) || defined(__hppa) \
+  || defined(_MIPSEB)  || defined(_POWER) \
   || defined(__s390__)
 # define WORDS_BIGENDIAN 1
 
-#elif defined(__i386__) || defined(__alpha__) || defined(__i386) \
-  || defined(__ia64) || defined(__ia64__) \
-  || defined(_M_IX86) || defined(_M_IA64) \
-  || defined(_M_ALPHA) || defined(__amd64) \
+#elif defined(__i386__) || defined(__i386) \
+  || defined(__ia64)    || defined(__ia64__) \
+  || defined(_M_IX86)   || defined(_M_IA64) \
+  || defined(_M_ALPHA)  || defined(__amd64) \
   || defined(__amd64__) || defined(_M_AMD64) \
-  || defined(__x86_64) || defined(__x86_64__) \
-  || defined(_M_X64) || defined(__bfin__)
+  || defined(__x86_64)  || defined(__x86_64__) \
+  || defined(_M_X64)    || defined(__bfin__) \
+  || defined(__alpha__) || defined(__ARMEL__)
 # undef WORDS_BIGENDIAN
 
 #else
 # error can not detect the endianness!
 #endif
 '''
+
+conf = env.Configure(clean=False, help=False, config_h='config.h',
+                     custom_tests={'CheckPKGConfig' : CheckPKGConfig,
+                                   'CheckPKG' : CheckPKG})
 
 def DoConfigure():
     if GetOption('clean'):
@@ -276,65 +277,61 @@
         if not conf.CheckPKG('sqlite3'):
             Exit(1)
 
-    AddConfigItem('ENABLE_NLS', 1)
-    AddConfigItem('GETTEXT_PACKAGE', '"sunpinyin2"')
-    AddTestHeader('assert.h')
-    AddTestFunction('bind_textdomain_codeset')
-    AddTestFunction('dcgettext')
-    AddTestHeader('dlfcn.h')
-    AddTestFunction('exp2')
-    AddTestHeader('fcntl.h')
-    AddTestHeader('getopt.h')
-    AddTestFunction('getopt_long')
-    AddTestFunction('getpagesize')
-    AddTestFunction('get_opt')
-    AddTestHeader('iconv.h')
-    AddTestHeader('inttypes.h')
-    AddTestHeader('locale.h')
-    AddTestHeader('libintl.h')
-    AddTestHeader('limits.h')
-    AddTestHeader('locale.h')
-    AddTestFunction('log2')
-    AddTestHeader('memory.h')
-    AddTestFunction('memset')
-    AddTestFunction('mmap')
-    AddTestFunction('munmap')
-    AddTestFunction('setlocale')
-    AddTestFunction('strndup')
-    AddTestHeader('sys/mman.h')
-    AddTestHeader('sys/param.h')
-    AddTestHeader('sys/stat.h')
-    AddTestHeader('sys/types.h')
-    AddTestHeader('unistd.h')
-    AddTestHeader('wchar.h')
+    conf.Define('ENABLE_NLS', 1)
+    conf.Define('GETTEXT_PACKAGE', '"sunpinyin2"')
+    conf.CheckCHeader('assert.h')
+    conf.CheckFunc('bind_textdomain_codeset')
+    conf.CheckFunc('dcgettext')
+    conf.CheckCHeader('dlfcn.h')
+    conf.CheckFunc('exp2')
+    conf.CheckCHeader('fcntl.h')
+    conf.CheckCHeader('getopt.h')
+    conf.CheckFunc('getopt_long')
+    conf.CheckFunc('getpagesize')
+    conf.CheckFunc('get_opt')
+    conf.CheckCHeader('iconv.h')
+    conf.CheckCHeader('inttypes.h')
+    conf.CheckCHeader('locale.h')
+    conf.CheckCHeader('libintl.h')
+    conf.CheckCHeader('limits.h')
+    conf.CheckCHeader('locale.h')
+    conf.CheckFunc('log2')
+    conf.CheckCHeader('memory.h')
+    conf.CheckFunc('memset')
+    conf.CheckFunc('mmap')
+    conf.CheckFunc('munmap')
+    conf.CheckFunc('setlocale')
+    conf.CheckFunc('strndup')
+    conf.CheckCHeader('sys/mman.h')
+    conf.CheckCHeader('sys/param.h')
+    conf.CheckCHeader('sys/stat.h')
+    conf.CheckCHeader('sys/types.h')
+    conf.CheckCHeader('unistd.h')
+    conf.CheckCHeader('wchar.h')
 
     # add essential package requirements
-    AddConfigItem('PACKAGE', '"sunpinyin"')
-    AddConfigItem('PACKAGE_NAME', '"sunpinyin"')
-    AddConfigItem('PACKAGE_STRING', '"sunpinyin 2.0"')
-    AddConfigItem('PACKAGE_TARNAME', '"sunpinyin"')
-    AddConfigItem('PACKAGE_VERSION', '"2.0"')
-    AddConfigItem('VRESION', '"2.0"')
+    conf.Define('PACKAGE', '"sunpinyin"')
+    conf.Define('PACKAGE_NAME', '"sunpinyin"')
+    conf.Define('PACKAGE_STRING', '"sunpinyin 2.0"')
+    conf.Define('PACKAGE_TARNAME', '"sunpinyin"')
+    conf.Define('PACKAGE_VERSION', '"2.0"')
+    conf.Define('VRESION', '"2.0"')
 
     # append endianness checking defines
-    AppendEndianCheck()
-    
-    # generate config.h
-    f = file('config.h', 'w')
-    f.write(config_h_content)
-    f.close()
-
+    AppendEndianCheck(conf)
+
+    env = conf.Finish()
     # generate sunpinyin.pc
     f = file('sunpinyin-2.0.pc', 'w')
     content = (
-        'prefix='+prefix,
+        'prefix='+env['PREFIX'],
         'exec_prefix=${prefix}',
-        'libdir=${exec_prefix}/lib',
+        'libdir=' + libdir,
         'includedir=${exec_prefix}/include/sunpinyin-2.0',
         '',
         'Name: libsunpinyin',
         'Description: IME library based on Statistical Language Model',
-        'Version: 2.0.1',
+        'Version: %s' % version,
         'Requires: sqlite3',
         'Libs: -L${libdir} -lsunpinyin',
         'Cflags: ' + reduce(lambda a, b: a + ' ' + b,
@@ -343,12 +340,9 @@
         )
     f.write(reduce(lambda a, b: a + '\n' + b, content))
     f.close()
-    env = conf.Finish()
 
     if GetOS() != 'Darwin':
         env.ParseConfig('pkg-config sqlite3 --libs --cflags')
-
-    LinkOSHeader()
 
 DoConfigure()
 
@@ -376,3 +370,7 @@
     os.environ['TAR'] = env['TAR']
     os.environ['MAKE'] = env['MAKE']
     os.system('$MAKE -C raw clean WGET="$WGET" TAR="$TAR"')
+    os.system('$MAKE -C data clean WGET="$WGET" TAR="$TAR"')
+
+def DoInstall():
+    if not 'install' in COMMAND_LINE_TARGETS:

=== build/Makefile ===
SLM_SRC_DIR = ../src/slm
LEXICON_SRC_DIR = ../src/lexicon
PINYIN_SRC_DIR = ../src/pinyin

CORPUS_DIR = ../raw
SWAP_DIR = ../swap
RESULT_DIR = ../data

DICTFILE = ${CORPUS_DIR}/dict.utf8
CORPUSFILE = ${CORPUS_DIR}/corpus.utf8
TEST_CORPUSFILE = ${CORPUS_DIR}/test.utf8
REAL_CORPUSFILE = ${CORPUS_DIR}/BIGCORPUS

LMTARGET = lm_sc
IDS_FILE = ${SWAP_DIR}/${LMTARGET}.ids
SWAP_FILE = ${SWAP_DIR}/swap

#FILE NAMES for BIGRAM model
IDNGRAM_FILE = ${SWAP_DIR}/${LMTARGET}.id2gram
RAW_LM_FILE = ${SWAP_DIR}/${LMTARGET}.2gram 
SLM_FILE = ${SWAP_DIR}/${LMTARGET}.2gm 
SLM_INFO_FILE = ${SWAP_DIR}/${LMTARGET}.2gm.arpa 
TSLM_FILE = ${RESULT_DIR}/${LMTARGET}.t2g
TSLM_INFO_FILE = ${SWAP_DIR}/${LMTARGET}.t2g.arpa

#FILE NAMES for TRIGRAM model
IDNGRAM_FILE3 = ${SWAP_DIR}/${LMTARGET}.id3gram
RAW_LM_FILE3 = ${SWAP_DIR}/${LMTARGET}.3gram 
SLM_FILE3 = ${SWAP_DIR}/${LMTARGET}.3gm 
SLM_INFO_FILE3 = ${SWAP_DIR}/${LMTARGET}.3gm.arpa 
TSLM_FILE3 = ${RESULT_DIR}/${LMTARGET}.t3g
TSLM_INFO_FILE3 = ${SWAP_DIR}/${LMTARGET}.t3g.arpa
TSLM_REPACKED_FILE3 = ${SWAP_DIR}/${LMTARGET}.t3g.repacked
TSLM_UNPACKED_FILE3 = ${SWAP_DIR}/${LMTARGET}.t3g.arpa.unpacked

#Lexicon FILE names (raw resource and others)
PINYIN_TEXTFILE = ${CORPUS_DIR}/dict.utf8
PINYIN_NMP_TEXTFILE = ${SWAP_DIR}/dict_nmp.utf8
PYTRIE_FILE = ${RESULT_DIR}/pydict_sc.bin
PYTRIE_PRINTOUT = ${SWAP_DIR}/pydict_sc.log.utf8

test_corpus :
	if [ -e ${CORPUSFILE} ]; then unlink ${CORPUSFILE}; fi
	ln -s ${TEST_CORPUSFILE} ${CORPUSFILE}

real_corpus :
	if [ -e ${CORPUSFILE} ]; then unlink ${CORPUSFILE}; fi
	ln -s ${REAL_CORPUSFILE} ${CORPUSFILE}

ids :
	./mmseg -d ${DICTFILE} -f bin -s 10 -a 9 ${CORPUSFILE} >${IDS_FILE}

slmids3:
	./slmseg -d ${DICTFILE} -f bin -s 10 -m ${TSLM_FILE3} ${CORPUSFILE} >${IDS_FILE}
	cp ${TSLM_FILE3} ${TSLM_FILE3}.normal

slmids:
	./slmseg -d ${DICTFILE} -f bin -s 10 -m ${TSLM_FILE} ${CORPUSFILE} >${IDS_FILE}
	cp ${TSLM_FILE} ${TSLM_FILE}.normal

#second round bootstrap bigram
bs_bigram : slmids m2_idngram m2_slm m2_prune m2_thread m2_tslminfo

#This is the command to make a bigram model
bigram : ids m2_idngram m2_slm m2_prune m2_thread m2_tslminfo

m2_idngram : 
	./ids2ngram -n 2 -s ${SWAP_FILE} -o ${IDNGRAM_FILE} -p 5000000 ${IDS_FILE}
	rm -f ${SWAP_FILE}

m2_slm:	
	./slmbuild -n 2 -o ${RAW_LM_FILE} -w 120000 -c 0,2 -d ABS,0.005 -d ABS,0.6 -b 10 -e 9 ${IDNGRAM_FILE}

m2_prune: 
	./slmprune ${RAW_LM_FILE} ${SLM_FILE} R 40000 100000

m2_thread :
	./slmthread ${SLM_FILE} ${TSLM_FILE}

m2_tslminfo :
	./tslminfo -v -l ${DICTFILE} ${TSLM_FILE} >${TSLM_INFO_FILE}

#Use this to generate bigram non-threaded lm arpa information if needed
m2_info :
	./slminfo -p -v -l ${DICTFILE} ${SLM_FILE} >${SLM_INFO_FILE}

#second round bootstrap to make trigram model
bs_trigram : slmids3 m3_idngram m3_slm m3_prune m3_thread m3_tslminfo

#This is the command to make a trigram model
trigram : ids m3_idngram m3_slm m3_prune m3_thread m3_tslminfo

m3_idngram : 
	./ids2ngram -n 3 -s ${SWAP_FILE} -o ${IDNGRAM_FILE3} -p 5000000 ${IDS_FILE}
	rm -f ${SWAP_FILE}

m3_slm:	
	./slmbuild -n 3 -o ${RAW_LM_FILE3} -w 120000 -c 0,2,2 -d ABS,0.0005 -d ABS -d ABS,0.6 -b 10 -e 9 ${IDNGRAM_FILE3}

m3_prune: 
	./slmprune ${RAW_LM_FILE3} ${SLM_FILE3} R 100000 1250000 1000000

m3_thread :
	./slmthread ${SLM_FILE3} ${TSLM_FILE3}

m3_tslminfo :
	./tslminfo -p -v -l ${DICTFILE} ${TSLM_FILE3} >${TSLM_INFO_FILE3}

m3_tslmpack :
	./tslmpack ${TSLM_INFO_FILE3} ${DICTFILE} ${TSLM_REPACKED_FILE3}

m3_tslmunpack :
	./tslminfo -p -v -l ${DICTFILE} ${TSLM_REPACKED_FILE3} >${TSLM_UNPACKED_FILE3}

#Use this to generate trigram non-threaded lm arpa information if needed
m3_info :
	./slminfo -p -v -l ${DICTFILE} ${SLM_FILE3} >${SLM_INFO_FILE3}

#clean all intermedian file for building the model
model_clean :
	rm -f ${IDS_FILE}
	rm -f ${SWAP_FILE}
	rm -f ${IDNGRAM_FILE} ${RAW_LM_FILE}
	rm -f ${IDNGRAM_FILE3} ${RAW_LM_FILE3}

lexicon :
	./genpyt -i ${PINYIN_TEXTFILE} -o ${PYTRIE_FILE} -l ${PYTRIE_PRINTOUT} -s ${TSLM_FILE3}

lexicon2 :
	./genpyt -i ${PINYIN_TEXTFILE} -o ${PYTRIE_FILE} -l ${PYTRIE_PRINTOUT} -s ${TSLM_FILE}

=== data/Makefile ===
LM_SC_ARPA = ../raw/lm_sc.t3g.arpa
DICTFILE = ../raw/dict.utf8
PYTRIE_LOG = pydict_sc.log.utf8
LM_SC_BIN = lm_sc.t3g

all: pydict_sc.bin pydict_sc.bin.le pydict_sc.bin.be lm_sc.t3g.le lm_sc.t3g.be
	@echo done

$(LM_SC_BIN): $(LM_SC_ARPA) $(DICTFILE)
	./tslmpack $(LM_SC_ARPA) $(DICTFILE) $@

pydict_sc.bin: $(DICTFILE) $(LM_SC_BIN)
	./genpyt -i $(DICTFILE) -o $@ -l $(PYTRIE_LOG) -s $(LM_SC_BIN)

pydict_sc.bin.le: $(DICTFILE) $(LM_SC_BIN)
	./genpyt -e le -i $(DICTFILE) -o $@ -l $(PYTRIE_LOG) -s $(LM_SC_BIN)

pydict_sc.bin.be: $(DICTFILE) $(LM_SC_BIN)
	./genpyt -e be -i $(DICTFILE) -o $@ -l $(PYTRIE_LOG) -s $(LM_SC_BIN)

lm_sc.t3g.le: lm_sc.t3g
	./tslmendian -e le -i $(LM_SC_BIN) -o $@

lm_sc.t3g.be: lm_sc.t3g
	./tslmendian -e be -i $(LM_SC_BIN) -o $@

clean:
	@rm -f pydict_sc.bin pydict_sc.bin.le pydict_sc.bin.be lm_sc.t3g lm_sc.t3g.le lm_sc.t3g.be pydict_sc.log.utf8
	@echo cleaned

=== debian/changelog ===
sunpinyin (2.0.3~rc1-0ubuntu1) natty; urgency=low

  * New upstream release
  * Drop bump-new-pkgconfig-version.patch, arm-endianess.patch as its
    incorporated upstream
  * Refresh all remaining patches

 -- Bhavani Shankar <bhavi@ubuntu.com>  Thu, 25 Nov 2010 12:45:23 +0530

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
#
# Modified for sunpinyin package by 
# Liang Guo <bluestonechina@gmail.com> 2010

SCONS=scons 
POD2MAN=pod2man
PROGS=genpyt idngram_merge slminfo slmseg tslminfo getWordFreq ids2ngram \
      mmseg slmbuild slmprune slmthread tslmendian tslmpack

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  CXXFLAGS += -g
endif

CXXFLAGS += -pipe -DHAVE_CONFIG_H -DSUNPINYIN_DATA_DIR="/usr/lib/sunpinyin/data"

build: build-stamp
build-stamp: 
	dh_quilt_patch
	-$(SCONS)
	for p in $(PROGS); do $(POD2MAN) --section 1 doc/$$p.pod > doc/$$p.1; done
	touch build-stamp

clean: clean-patched 
clean-patched:
	dh_testdir
	dh_testroot
	-$(SCONS) -c
	-rm -r config.log config.h	\
		.sconf_temp .sconsign.dblite \
		src/host_os.h sunpinyin-2.0.pc
	-for p in $(PROGS); do rm doc/$$p.1; done
	dh_quilt_unpatch
	dh_clean 

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	-$(SCONS) install --prefix=$(DEB_DESTDIR)/usr --install-sandbox=debian/tmp
	-for p in $(PROGS); do install -D -m 0755 build/$$p $(CURDIR)/debian/tmp/usr/bin/$$p; done
	mkdir -p $(CURDIR)/debian/tmp/usr/share/sunpinyin/
	cp -r python $(CURDIR)/debian/tmp/usr/share/sunpinyin/
	dh_install --sourcedir=debian/tmp --fail-missing
	touch install-stamp

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs 
	dh_installexamples
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## sunpinyin 2.0.3

=== SConstruct ===
--- 
+++ 
@@ -45,6 +45,7 @@
            'src/pinyin/pinyin_seg.cpp',
            'src/pinyin/shuangpin_data.cpp',
            'src/pinyin/shuangpin_seg.cpp',
+           'src/pinyin/hunpin_seg.cpp',
            'src/ime-core/imi_context.cpp',
            'src/ime-core/imi_data.cpp',
            'src/ime-core/lattice_states.cpp',
@@ -100,6 +101,7 @@
          'src/pinyin/pinyin_data.h',
          'src/pinyin/syllable.h',
          'src/pinyin/shuangpin_data.h',
+         'src/pinyin/hunpin_seg.h',
          'src/pinyin/datrie_impl.h',
          'src/sunpinyin.h']
 
@@ -152,6 +154,12 @@
                        TAR=tar, MAKE=make, WGET=wget,
                        CPPPATH=['.'] + allinc())
 
+def PassVariables(envvar, env):
+    for (x, y) in envvar:
+        if x in os.environ:
+            print 'Warning: you\'ve set %s in the environmental variable!' % x
+            env[y] = os.environ[x]
+    
 env = CreateEnvironment()
 opts.Update(env)
 
@@ -178,34 +186,16 @@
 if GetOption('rpath') is not None and GetOS() != 'Darwin':
     env.Append(LINKFLAGS='-Wl,-R -Wl,%s' % GetOption('rpath'))
 
-if 'CC' in os.environ:
-    print 'Warning: you\'ve set %s as C compiler' % os.environ['CC']
-    env['CC']=os.environ['CC']
-    
-if 'CXX' in os.environ:
-    print 'Warning: you\'ve set %s as C++ compiler' % os.environ['CXX']
-    env['CXX']=os.environ['CXX']
-
-if 'CFLAGS' in os.environ:
-    print 'Warning: you\'ve set an external compiler flags for C.'
-    env['CFLAGS'] = os.environ['CFLAGS']
-
-if 'CXXFLAGS' in os.environ:
-    print 'Warning: you\'ve set an external compiler flags for C++.'
-    env['CXXFLAGS'] = os.environ['CXXFLAGS']
-
-if 'TAR' in os.environ:
-    print 'Warning: you\'ve set %s as tar' % os.environ['TAR']
-    env['TAR'] = os.environ['TAR']
-
-if 'MAKE' in os.environ:
-    print 'Warning: you\'ve set %s as make' % os.environ['MAKE']
-    env['MAKE'] = os.environ['MAKE']
-
-if 'WGET' in os.environ:
-    print 'Warning: you\'ve set %s as wget' % os.environ['WGET']
-    env['WGET'] = os.environ['WGET']
-
+# pass through environmental variables
+envvar = [('CC', 'CC'),
+          ('CXX', 'CXX'),
+          ('CFLAGS', 'CFLAGS'),
+          ('CXXFLAGS', 'CXXFLAGS'),
+          ('LDFLAGS', 'LINKFLAGS'),
+          ('TAR', 'TAR'),
+          ('MAKE', 'MAKE'),
+          ('WGET', 'WGET')]
+PassVariables(envvar, env)
 
 # append critical cflags
 extra_cflags=' -DHAVE_CONFIG_H -DSUNPINYIN_DATA_DIR=\'"%s"\'' % libdatadir
@@ -374,3 +364,13 @@
 
 def DoInstall():
     if not 'install' in COMMAND_LINE_TARGETS:
+        return
+
+    lib_target = None
+    if GetOS() == 'Darwin':
+        lib_target = env.Install(libdir, lib)
+    else:
+        lib_target_bin = env.InstallAs(libdir + '/' + libname, lib)
+        install_path = os.path.dirname(str(lib_target_bin[0])) + '/'
+        lib_target = [
+            lib_target_bin,

=== build/Makefile ===
--- 
+++ 
@@ -61,18 +61,21 @@
 #second round bootstrap bigram
 bs_bigram : slmids m2_idngram m2_slm m2_prune m2_thread m2_tslminfo
 
+#second round bootstrap bigram from a trigram model
+bs_bigram3 : slmids3 m2_idngram m2_slm m2_prune m2_thread m2_tslminfo
+
 #This is the command to make a bigram model
 bigram : ids m2_idngram m2_slm m2_prune m2_thread m2_tslminfo
 
 m2_idngram : 
-	./ids2ngram -n 2 -s ${SWAP_FILE} -o ${IDNGRAM_FILE} -p 5000000 ${IDS_FILE}
+	./ids2ngram -n 2 -s ${SWAP_FILE} -o ${IDNGRAM_FILE} -p 20000000 ${IDS_FILE}
 	rm -f ${SWAP_FILE}
 
 m2_slm:	
-	./slmbuild -n 2 -o ${RAW_LM_FILE} -w 120000 -c 0,2 -d ABS,0.005 -d ABS,0.6 -b 10 -e 9 ${IDNGRAM_FILE}
+	./slmbuild -n 2 -o ${RAW_LM_FILE} -w 200000 -c 0,2 -d ABS,0.005 -d ABS -b 10 -e 9 ${IDNGRAM_FILE}
 
 m2_prune: 
-	./slmprune ${RAW_LM_FILE} ${SLM_FILE} R 40000 100000
+	./slmprune ${RAW_LM_FILE} ${SLM_FILE} R 100000 200000
 
 m2_thread :
 	./slmthread ${SLM_FILE} ${TSLM_FILE}
@@ -91,11 +94,11 @@
 trigram : ids m3_idngram m3_slm m3_prune m3_thread m3_tslminfo
 
 m3_idngram : 
-	./ids2ngram -n 3 -s ${SWAP_FILE} -o ${IDNGRAM_FILE3} -p 5000000 ${IDS_FILE}
+	./ids2ngram -n 3 -s ${SWAP_FILE} -o ${IDNGRAM_FILE3} -p 20000000 ${IDS_FILE}
 	rm -f ${SWAP_FILE}
 
 m3_slm:	
-	./slmbuild -n 3 -o ${RAW_LM_FILE3} -w 120000 -c 0,2,2 -d ABS,0.0005 -d ABS -d ABS,0.6 -b 10 -e 9 ${IDNGRAM_FILE3}
+	./slmbuild -n 3 -o ${RAW_LM_FILE3} -w 200000 -c 0,2,2 -d ABS,0.0005 -d ABS -d ABS -b 10 -e 9 ${IDNGRAM_FILE3}
 
 m3_prune: 
 	./slmprune ${RAW_LM_FILE3} ${SLM_FILE3} R 100000 1250000 1000000

=== debian/changelog ===
sunpinyin (2.0.3-2ubuntu1) oneiric; urgency=low

  * Add debian/libsunpinyin3.symbols.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 01 Jul 2011 17:43:29 +0100

sunpinyin (2.0.3-2) unstable; urgency=low

  * Build with prefix=$(DEB_DESTDIR)/usr (Close: #617752)
  * Fix FTBFS on SH (Close: #617753)
  * Fix FTBFS on MIPSEL.

 -- Liang Guo <bluestonechina@gmail.com>  Tue, 15 Mar 2011 00:20:57 +0800

sunpinyin (2.0.3-1) unstable; urgency=low

  * New Upstream Version 2.0.3.
  * Upload to unstable.
  * Update VCS field in debian/control.

 -- Liang Guo <bluestonechina@gmail.com>  Sat, 19 Feb 2011 10:38:38 +0800

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,8 @@
 Standards-Version: 3.9.1
 Section: libs
 Homepage: http://code.google.com/p/sunpinyin
+Vcs-Git: git://git.debian.org/git/collab-maint/sunpinyin
+Vcs-Browser: http://git.debian.org/?p=collab-maint/sunpinyin.git
 
 Package: libsunpinyin-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -14,12 +14,12 @@
   CXXFLAGS += -g
 endif
 
-CXXFLAGS += -pipe -DHAVE_CONFIG_H -DSUNPINYIN_DATA_DIR="/usr/lib/sunpinyin/data"
+CXXFLAGS += -pipe
 
 build: build-stamp
 build-stamp: 
 	dh_quilt_patch
-	-$(SCONS)
+	-$(SCONS)  --prefix=$(DEB_DESTDIR)/usr 
 	for p in $(PROGS); do $(POD2MAN) --section 1 doc/$$p.pod > doc/$$p.1; done
 	touch build-stamp
 
@@ -30,7 +30,7 @@
 	-$(SCONS) -c
 	-rm -r config.log config.h	\
 		.sconf_temp .sconsign.dblite \
-		src/host_os.h sunpinyin-2.0.pc
+		configure.conf sunpinyin-2.0.pc
 	-for p in $(PROGS); do rm doc/$$p.1; done
 	dh_quilt_unpatch
 	dh_clean

=== debian/watch ===
version=3
http://googlecode.debian.net/p/sunpinyin/sunpinyin-(\d+.*).tar.gz
